//------------------------------------------------------------------------------
// File: ResamplerPlugin.h
//------------------------------------------------------------------------------

#ifndef __RESAMPLER_PLUGIN__
#define __RESAMPLER_PLUGIN__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifdef BUILD_RESAMPLER
	#define _DLLCLASS __declspec( dllexport )
#else
	#define _DLLCLASS __declspec( dllimport )
#endif

class _DLLCLASS ResamplerPlugin
{
	int			m_inRate;
	int			m_outRate;
	int			m_channelCount;

	void*		m_privateData;

public:
	ResamplerPlugin();
	~ResamplerPlugin();

	int GetInputRate() { return m_inRate; }
	int GetOutputRate() { return m_outRate; }

	bool SetParameters(int quality, int channelCount, float peak_limit = 1.0f);
	bool SetRate(int inrate, int outrate);
	
	void ProcessFlow(float *inBuffer, int inSamples, float *outBuffer, int *outSamples, int maxOutSamples);

	void Flush();
};

#endif // __RESAMPLER_PLUGIN__
